#include <string.h>

#include "menu.h"
#include "myFunc.h"

////////////////////////////////////////////////////////////////////////////////////////
STUDENT  *addStudent(STUDENT *array,short *memoryFlag,short *numberElements,short submenu,short submenu1,short*lenghtArray)
{
	if(*memoryFlag==0)
	{
		array=(STUDENT*)malloc(rows*sizeof(STUDENT));
		if(array==NULL)
		{
			printf("\nNo allocated dynamic memory!");
			exit(1);
		}
		*memoryFlag=1;
		*lenghtArray=rows;
	}		
		
	array=submenu==1?addStudentFromKey(array,*memoryFlag,numberElements,submenu1,lenghtArray):addStudentFromFile(array,*memoryFlag,numberElements,submenu1,lenghtArray);
	return array;
}
///////////////////////////////////////////////////////////////////////////
STUDENT *addStudentFromKey(STUDENT *array,short memoryFlag,short *numberElements,short submenu1,short*lenghtArray)
{
	STUDENT a;
	char word[4];
	
	if(submenu1==1)
	{
		*numberElements=0;
	
	}
	
	while(printf("Will you enter a structure in the dynamic array? - (yes/no)"),strcmp(gets(word),"yes")==0)
	{
		if(*numberElements<*lenghtArray)
		{
			printf("\nSTUDENT  NUMBER %d: ",*numberElements+1);
			inputStudent(&a);
			memcpy(&array[*numberElements],&a,sizeof(STUDENT));
		}
		else
		{
			*lenghtArray=*lenghtArray*2;
			array=(STUDENT*)realloc(array,*lenghtArray*sizeof(STUDENT));
				
			printf("\nSTUDENT  NUMBER %d: ",*numberElements+1);
			inputStudent(&a);
			memcpy(&array[*numberElements],&a,sizeof(STUDENT));
		}
		(*numberElements)++;
		fflush(stdin);		
	}
	return array;
}
//////////////////////////////////////////////////////////////////////////////////////////
STUDENT *addStudentFromFile(STUDENT *array,short memoryFlag,short *numberElements,short submenu1,short*lenghtArray)
{
	FILE *fp_out=NULL;
	char fname[256];
	short n=*lenghtArray;;
	if(memoryFlag==0)
	{
		printf("\nNo allocated dynamic memory!");
		exit(1);
	}

	fflush(stdin);
	if(submenu1==1)
	{
		*numberElements=0;	
		
	}
	
	puts("Enter file name for read");
	fflush(stdin);
	gets(fname);

	fp_out=fopen(fname,"r+b");
	if(fp_out==NULL)
	{
		printf( "File could not be opened\n" );
		exit(1);
	}
	
	while(1)
	{

		if(*numberElements<*lenghtArray)
		{
			if(fread(&array[*numberElements],sizeof(STUDENT),1,fp_out)!=1)
			{

				if(ferror(fp_out))
				{
					perror("Read error :");
					break;
				}
				if(feof(fp_out))
					break;	
			}
			(*numberElements)++;
		}
		else
		{
			*lenghtArray=n=*lenghtArray*2;
			array=(STUDENT*)realloc(array,*lenghtArray*sizeof(STUDENT));
			if(fread(&array[*numberElements],sizeof(STUDENT),1,fp_out)!=1)
			{

				if(ferror(fp_out))
				{
					perror("Read error :");
					break;
				}
				if(feof(fp_out))
					break;	
			}
			(*numberElements)++;
		}
	}
	fclose(fp_out);	
	return array;
}
//////////////////////////////////////////////////////////////////////////////////////////
void inputStudent(STUDENT *a)
{	
	printf("\nEnter name of student:");
	gets(a->name);
	printf("\nEnter average mark of student:");
	scanf("%f",&a->averageMark);
	printf("\nEnter date of birth :");
	printf("\nDay - ");scanf("%d",&a->date_a.day);
	printf("\nMonth - ");scanf("%d",&a->date_a.month);
	printf("\nYear - ");scanf("%d",&a->date_a.year);

}
//////////////////////////////////////////////////////////////////////////////////////////
void printArray(STUDENT *array,short n)
{
	short i;
	if(n>0)
		for(i=0;i<n;i++)	
			printStudents(array,i);
		else	
			printf("\ndynamic array is empty!\n");	

}
/////////////////////////////////////////////////////////////////////////////////////////////////
void printStudents(STUDENT *array,short i)
{
			printf("\nElement number %d",i+1);
			printf("\nName :%s",array[i].name);
			printf("\nAverage mark :%.1f",array[i].averageMark);
			printf("\nDate of birth :%02d/%02d/%04d\n",array[i].date_a.day,array[i].date_a.month,array[i].date_a.year);
}
//////////////////////////////////////////////////////////////////////////////////////////////////
void writeStructFile(STUDENT *array,short numberElements)
{
	FILE *fp_in=NULL;
	char fname[256];
	short i;

	if(numberElements>0)
	{
		puts("Enter file name for writing");
		fflush(stdin);
		if(gets(fname)==NULL)
			printf("enter filename error");			
	
		fp_in=fopen(fname,"w+b");
		if(fp_in==NULL)
		{
			printf( "Problem opening the file\n" );
			exit(1);
		}

		for(i=0;i<numberElements;i++)
		{
			fwrite(&array[i],sizeof(STUDENT),1,fp_in);
			if(ferror(fp_in))
			{
				perror("Write error :");
				break;
			}
		}
		fclose(fp_in);
	}
	else
		printf("\nDynamic array is empty!\n");
	system("pause");	
}
/////////////////////////////////////////////////////////////////////////////////////////
STUDENT *deleteArray(STUDENT *array,short *n)
{
	if(array!=NULL)
	{
		free(array);
		*n=0;
		printf("\nDynamic memory was free!");
	}
	else
		printf("\nNo dynamic memory!");
	return array;
}
/////////////////////////////////////////////////////////////////////////////////

void sortArray(STUDENT *array,short n,short submenu,short *sortFlag)
{	
	qsort((void*)array,n,sizeof(STUDENT),submenu==2?sortAverageMark:sortName);
	*sortFlag=1;
}
//////////////////////////////////////////////////////////////////////////////
int sortName(const void *pa,const void *pb)
{
	char x;
	STUDENT*a=(STUDENT*)pa;
	STUDENT*b=(STUDENT*)pb;

	x=strcmp(a->name,b->name);
	if(x>0)
		return 1;
	else
		if(x<0)
			return -1;
		else
			return 0;
}
//////////////////////////////////////////////////////////////////////////
int sortAverageMark(const void *pa,const void *pb)
{
	STUDENT*a=(STUDENT*)pa;
	STUDENT*b=(STUDENT*)pb;

	if(a->averageMark > b->averageMark)
		return 1;
	else
		if(a->averageMark
			< b->averageMark)
			return -1;
		else
			return 0;
}
////////////////////////////////////////////////////////////////////////////////////

void findMaxAverageMark(STUDENT *array,short n)
{
	short i,j;
	float max;
	max=array[0].averageMark;
	for(i=1;i<n;i++)
	{
		if(array[i].averageMark>max)
		{
			max=array[i].averageMark;
			j=i;
		}
	}
	printf("\nSTUDENT WITH MAX AVERAGE MARK");
	printStudents(array,j);
}
//////////////////////////////////////////////////////////////////////////////////////////
void findByName(STUDENT *array,short n)
{
	short i,flag=0;
	char name[25];
	puts("Enter name for search :");
	fflush(stdin);
	if(gets(name)==NULL)
		printf("enter name error");

	for(i=0;i<n;i++)
	{
		if(strcmp(array[i].name,name)==0)
		{
			
			printf("\nFIND ELEMENT BY NAME FIELD");
			printStudents(array,i);
			flag++;
		}
	}
	if(flag==0)
		printf("\nStudent with such name no exist!");
}
///////////////////////////////////////////////////////////////////////////////
void findByAverageMark(STUDENT *array,short n)
{
	short i,flag=0;
	float avMark;
	puts("Enter average mark for search :");
	scanf("%f",&avMark);
	for(i=0;i<n;i++)
	{
		if(array[i].averageMark==avMark)
		{
			printf("\nFIND ELEMENT AVERAGE MARK FIELD");
			printStudents(array,i);
			flag++;
		}
	}
	if(flag==0)
		printf("\nStudent with such average mark no exist!");
}
/////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
void deleteElement(STUDENT *array,short n,short j)
{
	array[j]=array[n-1];
}

//////////////////////////////////////////////////////////////////////////////////////////
short deleteElementByName(STUDENT *array,short n,short submenu1,short sortFlag)
{
	short i,flag=0;
	char name[25];

	puts("Enter name for search :");
	fflush(stdin);
	if(gets(name)==NULL)
		printf("enter name error");

	for(i=0;i<n;i++)
	{
		if(strcmp(array[i].name,name)==0)
		{
			if(submenu1==2&&sortFlag==0)
			{
				printf("\nDynamic array no sorted!");
				return n;
			}
			submenu1==1?deleteElement(array,n,i):deleteElementInSortArray(array,n,i);
			flag++;
		}
		
	}
	if(flag!=0)
		n=n-1;
		
	else
		printf("\nStudent with such name no exist!");
		
	return n;
}
/////////////////////////////////////////////////////////////////////////////////////////////
short deleteElementByAverageMark(STUDENT *array,short n,short submenu1,short sortFlag)
{
	short i,flag=0;
	float k;

	puts("Enter average mark for search :");
	fflush(stdin);
	if(scanf("%f",&k)!=1)
		printf("enter data error");

	for(i=0;i<n;i++)
	{
		if(array[i].averageMark==k)
		{
			if(submenu1==2&&sortFlag==0)
			{
				printf("\nDynamic array no sorted!");
				return n;
			}
			submenu1==1?deleteElement(array,n,i):deleteElementInSortArray(array,n,i);
			flag++;
		}
		
	}
	if(flag!=0)
		n=n-1;		
	else
		printf("\nStudent with such average mark no exist!");
		
	return n;
}
/////////////////////////////////////////////////////////////////////////////////////////////

short deleteElementByIndex(STUDENT *array,short n,short submenu1,short sortFlag)
{
	short i,flag=0,k;
	
	puts("Enter index for search :");
	fflush(stdin);
	if(scanf("%d",&k)!=1)
		printf("enter data error");

	for(i=0;i<n;i++)
	{
		if(i==k)
		{
			if(submenu1==2&&sortFlag==0)
			{
				printf("\nDynamic array no sorted!");
				return n;
			}
			submenu1==1?deleteElement(array,n,i):deleteElementInSortArray(array,n,i);
			flag++;
		}
		
	}
	if(flag!=0)
		n=n-1;		
	else
		printf("\nIndex with such size no exist!");
		
	return n;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////
void deleteElementInSortArray(STUDENT *array,short n,short j)
{
	short i;
	for(i=j;i<n-1;i++)
		array[i]=array[i+1];
}

//////////////////////////////////////////////////////////////////
